(* Script for Clear Soloes *)
tell application "GarageBand"
	activate
	
	(* Get number of tracks *)
	set theSong to first song
	set allTracks to every track of first song
	set numTracks to count of allTracks
	
	(* Look up selected track *)
	set selectedTrack to 0
	set thisTrack to 1
	repeat with eachTrack in allTracks
		if selected of eachTrack is true then
			set selectedTrack to thisTrack
			exit repeat
		end if
		set thisTrack to thisTrack + 1
	end repeat
	
	(* Assume master track is selected if none is *)
	if selectedTrack is 0 then
		set selectedTrack to thisTrack
	end if
	
	(* Scroll to top *)
	set ourTrack to selectedTrack
	activate
	repeat while ourTrack is greater than 1
		tell application "System Events"
			tell process "GarageBand"
				key code 7 * 16 + 14
			end tell
		end tell
		set ourTrack to ourTrack - 1
	end repeat
	
	(* Scroll through tracks turning off mute *)
	activate
	repeat with eachTrack in allTracks
		if soloed of eachTrack is true then
			tell application "System Events"
				tell process "GarageBand"
					keystroke "s"
				end tell
			end tell
		end if
		if ourTrack is less than numTracks then
			tell application "System Events"
				tell process "GarageBand"
					key code 7 * 16 + 13
				end tell
			end tell
			set ourTrack to ourTrack + 1
		end if
	end repeat
	
	(* Return to selected track *)
	activate
	repeat while ourTrack is greater than selectedTrack
		tell application "System Events"
			tell process "GarageBand"
				key code 7 * 16 + 14
			end tell
		end tell
		set ourTrack to ourTrack - 1
	end repeat
end tell
